<?php
/*
Plugin Name: 123 Attachment Shortlink
Plugin URI: http://schnurpsel.de/?p=559
Description: Shortlinks für Attachments (z.B. Bilder) mit <em>example.org/?a=123</em>.
Author: Ingo Henze
Version: 0.10
Author URI: http://putzlowitsch.de/
*/ 

function plw123as_redirect_canonical( $redirect_url, $requested_url ) {
	global $wp_query;
	
	if( isset($wp_query->query_vars['a']) ) {
		$id = intval( $wp_query->query_vars['a'] );
		$url = wp_get_attachment_url( $id );
		if( '' == $url ) {
			$wp_query->set_404();
			status_header( 404 );
			$redirect_url = false;	
		}
		else
			$redirect_url = $url;	
	}
	return $redirect_url;
}

function plw123as_init() {
 global $wp;

 // Variable bekannt machen
 $wp->add_query_var( 'a' );
 add_filter( 'redirect_canonical', 'plw123as_redirect_canonical', 10, 2 );
}
add_action( 'init', 'plw123as_init' );  	

?>